//https://www.shadertoy.com/view/Xl3cDn
precision highp float;

uniform vec3                iResolution;
uniform float               iTime;
uniform sampler2D           iChannel0;
uniform sampler2D			iChannel1;
varying vec2                texCoord;
uniform float               intensity;
void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
	// Normalized pixel coordinates (from 0 to 1)
	vec2 uv = fragCoord/iResolution.xy;

	// Readbackground and foreground images.
	vec3 bg = texture2D(iChannel0, uv).rgb;

	// Film grain, from
	// https://www.reddit.com/r/opengl/comments/1rr4fy/any_good_ways_of_generating_film_grain_noise
	float noiseStrength = 50.0;
	float x = (uv.x + 4.0) * (uv.y + 4.0) * (1000.0 * 10.0);
	vec3 grain = vec3(mod((mod(x, 13.0) + 1.0) * (mod(x, 123.0) + 1.0), 0.01) - 0.005) * noiseStrength;

	fragColor = vec4(bg+intensity*grain,1.0);
}
void main() {
	mainImage(gl_FragColor, texCoord * iResolution.xy);
}