precision highp float;

uniform vec3                iResolution;
uniform float               iTime;
uniform sampler2D           iChannel0;
varying vec2                texCoord;
uniform float               intensity;

float rand(float co) { return fract(sin(co*(91.3458)) * 47453.5453); }
float rand(vec2 co){ return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453); }
float rand(vec3 co){ return rand(co.xy+rand(co.z)); }

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
	// Normalized pixel coordinates (from 0 to 1)
	vec2 uv = fragCoord/iResolution.xy;

	// Calculate noise and sample texture
	float mdf = intensity*0.4; // increase for noise amount
	vec4 noise = vec4(
	rand(vec3(iTime*3.0, uv.x, uv.y)),
	rand(vec3(iTime*1.0, uv.y, uv.x)),
	rand(vec3(iTime*0.3, cos(uv.x), uv.y)),
	1.0);
	vec4 tex = texture2D(iChannel0, uv);

	vec4 col = tex - (noise * mdf);
	// Output to screen
	fragColor = col;
}

void main() {
	mainImage(gl_FragColor, texCoord * iResolution.xy);
}