// Fork of "Simple Film Grain Shader" by terchapone. https://shadertoy.com/view/3sGGRz
// 2022-04-24 03:48:40
precision highp float;
uniform vec3                iResolution;
uniform float               iTime;
uniform sampler2D           iChannel0;
uniform sampler2D			iChannel1;
varying vec2                texCoord;
uniform float               intensity;

const float grainFactor = 0.2; //[0.0, 1.0]

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
	// Normalized pixel coordinates (from 0 to 1)
	vec2 uv = fragCoord/iResolution.xy;

	// Calculate noise and sample texture
	float mdf = intensity*0.4; // increase for noise amount
	float noise = (fract(sin(dot(uv, vec2(12.9898,78.233)*2.0)) * 43758.5453));
	vec4 tex = texture2D(iChannel0, uv);
	vec4 col = tex - noise * mdf;

	// Output to screen
	fragColor = col;
}

void main() {
	mainImage(gl_FragColor, texCoord * iResolution.xy);
}