//https://www.shadertoy.com/view/wlGGWw
precision highp float;

uniform vec3                iResolution;
uniform float               iTime;
uniform sampler2D           iChannel0;
uniform sampler2D			iChannel1;
varying vec2                texCoord;
uniform float               intensity;

float rand(vec2 uv, float t) {
	return fract(sin(dot(uv, vec2(1225.6548, 321.8942))) * 4251.4865 + t);
}

void mainImage(out vec4 color, vec2 coord) {
	vec2 ps = vec2(1.0) / iResolution.xy;
	vec2 uv = coord * ps;
	vec3 iMouse = vec3(0.0);
	float scale = 15.0;
//	if (iMouse.z > 0.0)
//	scale *= iMouse.x * ps.x * 2.0;

	vec2 offset = (rand(uv, iTime) - 0.5) * 2.0 * ps * scale;

	vec3 noise = texture2D(iChannel0, uv + offset).rgb;
	color = texture2D(iChannel0, uv);

	float amount = intensity;
//	if (iMouse.z > 0.0)
//	amount = iMouse.y * ps.y;

	color.rgb = mix(color.rgb, noise, amount);
}

void main() {
	mainImage(gl_FragColor, texCoord * iResolution.xy);
}